//This program reads a VSL program and compile it
//into a VSL object program Object.java. The result is a
//Java-Programm with a structure of an assembler-program.
//After compiling of Object.java by a standard java compiler,
//Object.obj will be linked with a run-time system to an
//executable program.
//This program is derived from the program for generating the
//postfix notation.
//

package compilerVSL;
/* @author spale */

import java.io.*;
import infix2suffix.*;

class ParserWithCodeOutput extends ParserWithPostfixOutput{	// inherited class
				// no new attributes added

	ParserWithCodeOutput(String infilename, String outfilename){	// Constructor
		super(infilename, outfilename);		// run constructor of the class ParserWithPostfixOutput
	}
// The following methods of the class Parser are used
//	nextchar() void
//	errorpriv(String) void
//
//	The following methods of the class ParserWithPostfixOutput are used
//  analyze() void
//  close() void

	protected void expression(){	//overloaded method;
									//must be protected: more public that the
									//super-method ist not possible
		char optor;
		term();
		while (buf == '+' || buf == '-'){
			optor = buf;
			nextchar();
			term();
			try {
				outFile.write(optor == '+' ?
						"\t\ts.add();\n" : "\t\ts.subtract();\n");
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
		}
	}

	protected void term(){	// Overloded method
		factor();
		while (buf == '*'){
			nextchar();
			factor();
			try {
				outFile.write("\t\ts.multiply();\n");
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
		}
	}

	protected void factor(){		// overloaded method
									// what can be a factor
		if (buf >= '0' && buf <= '9')	// a number
			try {
				outFile.write("\t\ts.push("+buf+");\n");
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
		else if (buf == '(' ){			// (
			nextchar();
			expression();
			if (buf != ')' )
				errorpriv("')' expected");
			}
		else
			errorpriv("Number or '(' expected"); // otherwise error
		nextchar();
	}

	public void analyze(){			//  overloaded method
		try {
			outFile.write("//This program was generated automatically by CompilerVSL.java\n\n");
			outFile.write("package runtimesystem;\n\n");
			outFile.write("public class Object {\n");
			outFile.write("\tpublic static void main(String[] args) {\n");
			outFile.write("\t\tStackVSL s = new StackVSL();\n");
			nextchar();
			if (buf != '{')
				errorpriv("Opening brace ({) expected");
			nextchar();
			expression();
			if (buf != '}')
				errorpriv("Closing brace (}) expected");
			outFile.write("\t\ts.printresult();\n");
			outFile.write("\t}\n");
			outFile.write("}\n");
		}
		catch(IOException e){
			System.out.println("Error while writing to the file:\n");
			System.exit(-1);
		}
	}

}
