//Conversion from Infix into Postfix;
//The Program reads a VSL-Program in form
//
//	{ Expression }
//
//The Expression will be converted into the Suffix-Notation 
//and writen in another file. 
//The names of both files are user-defined.
//

package infix2suffix;
/* @author spale */

import java.io.*;

public class Infix2suffix {
	public static void main(String[] args) throws IOException {
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		int ch;
		System.out.println("This program read an input file, which contains a VSL- Program");
		System.out.println("e.g. {3 - 2 * 5} \n");
		System.out.print("Input file name: "); 
		String inFileName=console.readLine();
		System.out.print("Output file name: "); 
		String outFileName=console.readLine();
		ParserWithPostfixOutput infix
			=new ParserWithPostfixOutput(inFileName,outFileName);
        System.out.println("reading a VSL program from the file...:"); 
		infix.analyze();
		infix.close();
		try {
			System.out.println("\nContent of input file (Infix):");
            BufferedReader inFile=new BufferedReader (
            		new FileReader(inFileName));
 			while ((ch = inFile.read()) != -1) 
 			 	System.out.print((char)ch);
 			inFile.close();
 			System.out.println();
			System.out.println("\nContent of output file (Postfix):");
            BufferedReader outFile=new BufferedReader (
            		new FileReader(outFileName));
 			while ((ch = outFile.read()) != -1) 
 			 	System.out.print((char)ch);
 			outFile.close();
 			System.out.println();
		}
        catch (FileNotFoundException e) {
			System.out.println("IOERROR: File not available:\n");
			System.exit(-1);
		} 
 		catch ( IOException e ) {
			System.out.println("IOERROR: " + e.getMessage() + "\n");
			e.printStackTrace();
			System.exit(-1);
		}
	}
}



