//Conversion from Infix into Postfix;
//The Program reads a VSL-Program in form
//
//	{ Expression }
//
//The Expression will be converted into the Suffix-Notation 
//and writen in another file. 
//The names of both files are user-defined.
//

package infix2suffix;
/* @author spale */

import java.io.*;
import interpreterVSL.*;

public class ParserWithPostfixOutput extends Parser{	// inherited class
	protected BufferedWriter outFile;		// attribute added
	
	protected ParserWithPostfixOutput(String infilename, String outfilename){	// Constructor
		super(infilename);		// run constructor of the class Parser
        try {
            outFile=new BufferedWriter (
            		new FileWriter(outfilename));
    		} 
        catch (IOException e) {
			System.out.println("Error while writing to the file:\n");
			System.exit(-1);
		} 
	}
// The following methods of the class Parser are used
//	nextchar() void
//	errorpriv(String) void
//  
	
	protected void expression(){	//new method
		char optor;
		term();
		while (buf == '+' || buf == '-'){
			optor = buf;
			nextchar(); 
			term();
			try {
				outFile.write(optor);
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
		}
	}
	
	protected void term(){
		factor(); 
		while (buf == '*'){
			nextchar(); 
			factor();
			try {
				outFile.write('*');
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
			}
	}
	
	protected void factor(){		// what can be a factor
		if (buf >= '0' && buf <= '9')	// a number
			try {
				outFile.write(buf);
			}
			catch(IOException e){
				System.out.println("Error while writing to the file:\n");
				System.exit(-1);
			}
		else if (buf == '(' ){			// (
			nextchar(); 
			expression(); 
			if (buf != ')' )
				errorpriv("')' expected");
			}
		else
			errorpriv("Number or '(' expected"); // otherwise error
		nextchar();
	}
	
	public void analyze(){			//  new method
		nextchar();
		if (buf != '{')
			errorpriv("Opening brace ({) expected");
		nextchar();
		expression(); 
		if (buf != '}')
			errorpriv("Closing brace (}) expected"); 
	}
	
	public void close() {		// overloaded method
		// without protected in Parser: it would be a new method,
		// other that Parser.close()...also possible
		try {
			inFile.close();
			outFile.close();		// close the stream
		}
		catch ( IOException e ) {
			System.out.println("IOERROR: " + e.getMessage() + "\n");
			e.printStackTrace();
			System.exit(-1);
		}
	}
}
