//A Source-code interpreter for a
//Very Simple Language

package interpreterVSL;
/* @author spale */

import java.io.*;

public class Parser {
	protected BufferedReader inFile;
	protected char buf;
	
	protected Parser(String filename){	// Konstruktor
		//Read from textfile:
        try {
            inFile=new BufferedReader (
            		new FileReader(filename));
    		} 
        catch (FileNotFoundException e) {
			System.out.println("IOERROR: File not available:\n");
			System.exit(-1);
		} 
	}
		
	protected void nextchar(){
		try {
			int ch;
			do {
				if ((ch = inFile.read()) != -1) 
					buf = (char)ch;
				else 
					errorpriv("End of File reached");
				}
			while (buf == ' ' || buf == '\n');
		}
		catch ( IOException e ) {
			System.out.println("IOERROR: " + e.getMessage() + "\n");
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	protected void errorpriv (String str)	{ //protected because of used by ParserWithOutput
		System.out.println("\nError: "+str);
		System.exit(-1);
	}
	
	private int expression(){
		char optor;
		int x = term();
		while (buf == '+' || buf == '-'){
			optor = buf;
			nextchar(); 
			int y = term();
			if (optor == '+') 
				x += y; 
			else
				x -= y;
		}
		return x;
	}
	
	private int term(){
		int x = factor(); 
		while (buf == '*'){
			nextchar(); 
			x *= factor();
			}
		return x;
	}
	
	private int factor(){		// what can be a factor
		int x=0;
		if (buf >= '0' && buf <= '9')	// a number
			x = buf - '0';
		else if (buf == '(' ){			// (
			nextchar(); 
			x = expression(); 
			if (buf != ')' )
				errorpriv("')' expected");
			}
		else
			errorpriv("Number or '(' expected"); // otherwise error
		nextchar();
		return x;
	}
	
	int analyze(){		
		int x=0;
		nextchar();
		if (buf != '{')
			errorpriv("Opening brace ({) expected");
		nextchar();
		x = expression(); 
		if (buf != '}')		//the program recognize the end of the expression automatically
							//this is the check only
			errorpriv("Closing brace (}) expected"); 
		return x;
	}
	
	protected void close() {			
		try {
			inFile.close(); // close the stream
		}
		catch ( IOException e ) {
			System.out.println("IOERROR: " + e.getMessage() + "\n");
			e.printStackTrace();
			System.exit(-1);
		}
	}
}


