package runtimesystem;
/* @author spale */

import java.io.*;

public class PostfixInterpreter {
	public static void main(String[] args) throws IOException {
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		int ch;
		StackVSL Stack = new StackVSL();
		System.out.println("This program read an input file, which contains the potfix-notated expression");
		System.out.println("e.g. {32-5*} \n");
		System.out.print("Input file name: "); 
		String inFileName=console.readLine();
		try {
			System.out.println("\nContent of input file (Postfix):");
            BufferedReader inFile=new BufferedReader (
            		new FileReader(inFileName));
 			while ((ch = inFile.read()) != -1){
 				System.out.print((char)ch);
 				if (ch >= '0' && ch <= '9') 
 					Stack.push(ch - '0');
 				else if (ch == '+') 
 					Stack.add();
 				else if (ch == '-') 
 					Stack.subtract();
 				else if (ch == '*')
 					Stack.multiply(); 
 				else
 					break;
 			}
 			System.out.println();
 			Stack.printresult();
 			inFile.close();
 		}
        catch (FileNotFoundException e) {
			System.out.println("IOERROR: File not available:\n");
			System.exit(-1);
		} 
 		catch ( IOException e ) {
			System.out.println("IOERROR: " + e.getMessage() + "\n");
			e.printStackTrace();
			System.exit(-1);
		}
	}
}
